//
//  FTMediaWiki.h
//  FTMediaWiki - MediaWiki API client
//
//  Created by Federico Tortora on 31/10/11.
//  Copyright (c) 2011 CocoAdvanced. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ASIFormDataRequest.h"
#import "XMLReader.h"

extern NSString *const API_URL;

@interface FTMediaWiki : NSObject {
    NSString * username;
    NSString * password;
    BOOL logged;
}

-(FTMediaWiki *) initWithUsername:(NSString *) theUsername andPassword:(NSString *) thePassword;
-(NSString *) login;
-(BOOL) logout;
-(BOOL) uploadDirectlyWithData:(NSData *) theData toPage:(NSString *) pageTitle;
-(BOOL) uploadFromURL:(NSURL *) theUrl;
-(NSString *) getEditTokenWithPageTitle: (NSString * ) pageTitle;
-(BOOL) isLogged;

@property(nonatomic,retain) NSString * username;
@property(nonatomic,retain) NSString * password;

@end
