//
//  FTMediaWiki.m
//  FTMediaWiki - MediaWiki API client
//
//  Created by Federico Tortora on 31/10/11.
//  Copyright (c) 2011 CocoAdvanced. All rights reserved.
//

#import "FTMediaWiki.h"

@implementation FTMediaWiki

@synthesize username, password;
NSString * const API_URL = @"http://it.wikipedia.org/w/api.php";

-(FTMediaWiki *) initWithUsername:(NSString *) theUsername andPassword:(NSString *) thePassword {
    if(self = [super init]) {
        [self setUsername:theUsername];
        [self setPassword:thePassword];
        [self login];
    }
    
    return  self;
}

-(NSString *) login {
    NSString * message = [[NSString alloc] init];
    ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:API_URL ]];
    [request setPostValue:@"login" forKey:@"action"];
    [request setPostValue:username forKey:@"lgname"];
    [request setPostValue:password forKey:@"lgpassword"];
    [request setPostValue:@"xml" forKey:@"format"];
    
    [request startSynchronous];
    NSError *error = [request error];
    if (!error) {
        NSDictionary *dict = [XMLReader dictionaryForXMLString:[request responseString] error:&error];
        message = [[[dict objectForKey:@"api"] objectForKey:@"login"] valueForKey:@"result"] ;
        if ([[[[dict objectForKey:@"api"] objectForKey:@"login"] valueForKey:@"result"] isEqualToString:@"NeedToken"]) {
            message = [[[dict objectForKey:@"api"] objectForKey:@"login"] valueForKey:@"result"] ;
            request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:API_URL ]];
            
            [request setPostValue:@"login" forKey:@"action"];
            [request setPostValue:username forKey:@"lgname"];
            [request setPostValue:password forKey:@"lgpassword"];
            [request setPostValue:@"xml" forKey:@"format"];
            [request setPostValue:[[[dict objectForKey:@"api"] objectForKey:@"login"] valueForKey:@"token"] forKey:@"lgtoken"];
            
            [request startSynchronous];
            error = [request error];
            if (!error) {
                dict = [XMLReader dictionaryForXMLString:[request responseString] error:&error];
                NSLog(@"%@", [[[dict objectForKey:@"api"] objectForKey:@"login"] valueForKey:@"result"]);
                NSLog(@"%@", dict);
                if ([[[[dict objectForKey:@"api"] objectForKey:@"login"] valueForKey:@"result"] isEqualToString:@"Success"]) {
                    logged = YES;
                    message = [[[dict objectForKey:@"api"] objectForKey:@"login"] valueForKey:@"result"] ;
                }
            }
        }
    }
    return message;
}

-(BOOL) logout {
    if(logged) {
        ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:API_URL ]];
        [request setPostValue:@"logout" forKey:@"action"];
        [request startSynchronous];
        
        logged = NO;
    }
    return !logged;
}

-(BOOL) uploadDirectlyWithData:(NSData *) theData toPage:(NSString *) pageTitle {
    NSString * editToken = [self getEditTokenWithPageTitle:pageTitle];
    ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:API_URL ]];
    
    [request setPostValue:@"upload" forKey:@"action"];
    [request setPostValue:editToken forKey:@"token"];
    [request setPostValue:[NSString stringWithFormat:@"%@.png",pageTitle] forKey:@"filename"];
    [request setData:theData withFileName:[NSString stringWithFormat:@"%@.png",pageTitle] andContentType:@"image/png" forKey:@"file"];
    
    [request startSynchronous];
    
}

-(BOOL) uploadFromURL:(NSURL *) theUrl {
    
}

-(NSString *) getEditTokenWithPageTitle:(NSString *) pageTitle {
    NSString * editToken;
    // api.php ? action=query & prop=info & intoken=edit & titles=Foo
    ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:API_URL ]];
    [request setPostValue:@"query" forKey:@"action"];
    [request setPostValue:@"info" forKey:@"prop"];
    [request setPostValue:@"edit" forKey:@"intoken"];
    [request setPostValue:pageTitle forKey:@"titles"];
    [request startSynchronous];
    
    NSError *error = [request error];
    if (!error) {
        NSDictionary * dict = [XMLReader dictionaryForXMLString:[request responseString] error:&error];
        editToken = [[[[[dict objectForKey:@"api"] objectForKey:@"query"] valueForKey:@"pages"] valueForKey:@"page"] valueForKey:@"edittoken"];
    }
    return editToken;
}

-(BOOL) isLogged {
    return logged;
}

@end
