//
//  GradientView.m
//  ShadowedTableView
//
//  Created by Matt Gallagher on 2009/08/21.
//  Copyright 2009 Matt Gallagher. All rights reserved.
//

#import "GradientView.h"
#import <QuartzCore/QuartzCore.h>

@implementation GradientView

//
// layerClass
//
// returns a CAGradientLayer class as the default layer class for this view
//
+ (Class)layerClass {
	return [CAGradientLayer class];
}

//
// setupGradientLayer
//
// Construct the gradient for either construction method
//
- (void)setupGradientLayer {
	CAGradientLayer * gradientLayer = (CAGradientLayer *) [self layer];
	[gradientLayer setColors:[NSArray arrayWithObjects:(id)[UIColor colorWithRed:1.0 green:1.0 blue:1.0 alpha:1.0].CGColor, (id)[UIColor colorWithRed:0.85 green:0.85 blue:0.85 alpha:1.0].CGColor, nil]];
	[self setBackgroundColor:[UIColor clearColor]];
}


//
// initWithFrame:
//
// Initialise the view.
//
- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
		CAGradientLayer * gradientLayer = (CAGradientLayer *)[self layer];
		[gradientLayer setColors:[NSArray arrayWithObjects:(id)[UIColor colorWithRed:1.0 green:1.0 blue:1.0 alpha:1.0].CGColor, (id)[UIColor colorWithRed:0.85 green:0.85 blue:0.85 alpha:1.0].CGColor, nil]];
		[self setBackgroundColor:[UIColor clearColor]];
	}
	return self;
}

// A little mod by Federico Tortora
- (id)initRed {
    if (self = [super init]) {
		CAGradientLayer * gradientLayer = (CAGradientLayer *)[self layer];
		[gradientLayer setColors:[NSArray arrayWithObjects:(id)[UIColor colorWithRed:200.0/255 green:0.0 blue:0.0 alpha:1.0].CGColor, (id)[UIColor colorWithRed:100.0/255 green:0.0 blue:0.0 alpha:1.0].CGColor, nil]];
		[self setBackgroundColor:[UIColor clearColor]];
	}
	return self;
}

- (id)initGreen {
    if (self = [super init]) {
		CAGradientLayer * gradientLayer = (CAGradientLayer *)[self layer];
		[gradientLayer setColors:[NSArray arrayWithObjects:(id)[UIColor colorWithRed:0.0 green:200.0/255 blue:0.0 alpha:1.0].CGColor, (id)[UIColor colorWithRed:0.0 green:100.0/255 blue:0.0 alpha:1.0].CGColor, nil]];
		[self setBackgroundColor:[UIColor clearColor]];
	}
	return self;
}

- (id)initBlue {
	if (self = [super init]) {
		CAGradientLayer * gradientLayer = (CAGradientLayer *)[self layer];
		[gradientLayer setColors:[NSArray arrayWithObjects:(id)[UIColor colorWithRed:0.0 green:0.0 blue:200.0/255 alpha:1.0].CGColor, (id)[UIColor colorWithRed:0.0 green:0.0 blue:100.0 alpha:1.0].CGColor, nil]];
		[self setBackgroundColor:[UIColor clearColor]];
	}
	return self;
}

@end
