//
//  WAPViewController.m
//  Wiki a picture
//
//  Created by Federico Tortora on 30/10/11.
//  Copyright (c) 2011 CocoAdvanced. All rights reserved.
//

#import "WAPViewController.h"

@implementation WAPViewController
@synthesize imageToUpload;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
}

- (IBAction)showPickerView {
    UIActionSheet *popupQuery;
    if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
        popupQuery = [[UIActionSheet alloc] initWithTitle:@"Select source" delegate:self cancelButtonTitle:@"Cancel" destructiveButtonTitle:nil otherButtonTitles: @"Photo library", @"Saved Photos Album", @"Camera", nil];
    } else {
        popupQuery = [[UIActionSheet alloc] initWithTitle:@"Select source" delegate:self cancelButtonTitle:@"Cancel" destructiveButtonTitle:nil otherButtonTitles: @"Photo library", @"Saved Photos Album", nil];
    }
    
    [popupQuery setActionSheetStyle:UIActionSheetStyleDefault];
    [popupQuery showInView:self.view];
    [popupQuery release];
}

-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
    UIImagePickerController *imagePicker = [[UIImagePickerController alloc] init];
    switch (buttonIndex) {
        case 0:
            [imagePicker setSourceType:UIImagePickerControllerSourceTypePhotoLibrary];
            break;
        case 1:
            [imagePicker setSourceType:UIImagePickerControllerSourceTypeSavedPhotosAlbum];
            break;
        case 2:
            if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
                [imagePicker setSourceType:UIImagePickerControllerSourceTypeCamera];
            } else {
                return;
            }
            break;
        default:
            return;
            break;
    }
    
    [imagePicker setAllowsEditing:YES];
	[imagePicker setDelegate:self];
	[self presentModalViewController:imagePicker animated:YES];
	[imagePicker release];
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingMediaWithInfo:(NSDictionary *)info {
    imageToUpload = [info objectForKey:UIImagePickerControllerEditedImage];
	[self dismissModalViewControllerAnimated:NO];
        [self checkSettings];
}


- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
	[self dismissModalViewControllerAnimated:YES];
}

- (void)settingsViewControllerDidEnd:(IASKAppSettingsViewController*)sender {
    [self dismissModalViewControllerAnimated:NO];
	
    [self checkSettings];
}

- (void) checkSettings {
    IASKAppSettingsViewController *appSettingsViewController = [[IASKAppSettingsViewController alloc] initWithNibName:@"IASKAppSettingsView" bundle:nil];
    if ([[[NSUserDefaults standardUserDefaults] valueForKey:@"username"] isEqualToString:@""] || [[[NSUserDefaults standardUserDefaults] valueForKey:@"password"] isEqualToString:@""] || [[[NSUserDefaults standardUserDefaults] valueForKey:@"geoUsername"] isEqualToString:@""]) {
        [appSettingsViewController setDelegate:self];    
        [appSettingsViewController setShowDoneButton:YES];
        [self presentModalViewController:[[UINavigationController alloc] initWithRootViewController:appSettingsViewController] animated:YES];
    } else {
        [self connectAndUpload];
    }
}

- (void) connectAndUpload {
    WAPAroundMeViewController *_WAPAroundMeViewController = [[WAPAroundMeViewController alloc] initWithNibName:@"WAPAroundMeViewController" bundle:nil];
    [_WAPAroundMeViewController setImageToUpload:imageToUpload];
    [self presentModalViewController:[[UINavigationController alloc] initWithRootViewController:_WAPAroundMeViewController] animated:YES];
}

@end
